#ifndef MENU_H_
#define MENU_H_

// Incluimos la cabecera principal de StdPijo
#include "StdPijo.h"

#include <iostream>

// Incluimos cabeceras para números aleatorios y retardos
#include <ctime>
#include <cstdlib>
#include <unistd.h>
#include <fstream>
#include "string.h"
#include "juego.h"

using namespace std;

typedef struct{
	char nombre[3]; //Guarda las iniciales del jugador que consigue un récord
	int puntuacion; //Guarda la puntuación del récord
	int nivel; //Guarda el nivel donde se ha finalizado la partida del récord
}TRankingRecord;

typedef TRankingRecord TRanking[10];

class Menu{
private:
	bool logros[5]; //Booleanos que guardan los logros desbloqueados
	int posicionAnimacion; //Enteros que guardan la posición del "cursor" en los diferentes menús
	int posicionMenu;
	int posicionMenuJuego;
	int posicionMenuOpciones;
	int posicionMenuRanking;
	int posicionMenuInstrucciones;
	TRanking ranking[2]; //Estructuras de las dos tablas de récords

public:
	Menu(){
		posicionAnimacion=0;
		posicionMenu=0;
		posicionMenuJuego=0;
		posicionMenuOpciones=0;
		posicionMenuRanking=0;
		posicionMenuInstrucciones=0;

		for(int i=0; i<5;i++){
			logros[i]=false;
		}

		for(int i =0; i<10; i++){
			for(int j = 0; j<3; j++){
			ranking[0][i].nombre[j]=65;
			ranking[1][i].nombre[j]=65;
			}

			ranking[0][i].puntuacion=0;
			ranking[1][i].puntuacion=0;

			ranking[0][i].nivel=0;
			ranking[1][i].nivel=0;

		}
	}
	void iniciarMenu(); //Iniciamos el menú con sus elementos
	void mostrarCabecera(); //Muestra la cabecera del menú correspondiente
	void mostrarCabeceraOpciones();
	void mostrarCabeceraInstrucciones();
	void mostrarCabeceraRanking();
	void mostrarCabeceraLogros();
	void mostrarDecorado(); //Muestra el decorado sobre el que se desarrolla la animación
	void mostrarAnimacion();
	int mostrarMenuPrincipal(); //Muestra los diferentes menús
	int mostrarMenuOpciones();
	int mostrarRanking(int posicionMenuRanking); //Muestra el contenido de las estructuras de los rankings
	int mostrarMenuLogros();
	int mostrarMenuInstrucciones();
	void procesarSeleccion(); //Procesa la opción elegida en el menú principal
	void mostrarLogroDesbloqueado(Juego juego); //Muestra una pantalla donde indica los logros desbloqueados por el jugador
	void mostrarCabeceraLogrosDesbloqueados();
	void gestionarRanking(Juego juego); //Se encarga de introducir los récords en las estructuras de rankings
	void guardarDatos(); //Guarda, carga o borra los datos en los archivos que crea
	void cargarDatos();
	void borrarDatos();

};

#endif /* MENU_H_ */
